YAHOO.namespace ("prodrequest");

function cannotConnectToServerAlert (o)
{
    alert ("Cannot connect to server");
}



function propertyTypingDone (type, args, me)
{
    var inputElement = args[0].inputElement;
    var value = inputElement.value;
    var entryId = args[0].entryId; 
    var key = args[0].key;
    var value_type = args[0].value_type; 

    var propertyEditingHandler = {
        success: function (o) {
            if (value === "")
            {
                value = "undefined";
            }
            inputElement.value = value;
        },
        failure: cannotConnectToServerAlert
    };
    
    YAHOO.util.Connect.asyncRequest ("GET",
                                     "../ProdRequest/setWorkflowEntryProperty"+
                                     "?entry_id=" + entryId +
                                     "&key=" + key +
                                     "&value=" + value +
                                     "&value_type=" + value_type,
                                     propertyEditingHandler,
                                     null);
}

function setDataset (datasetType, datasetName, entryId, handler)
{
    YAHOO.util.Connect.asyncRequest ("GET",
                                     "../ProdRequest/setWorkflowEntryDataset" + 
                                     "?dataset_name=" + datasetName.replace (/\+/g, "%2B") +
                                     "&run=1" +
                                     "&entry_id=" + entryId +
                                     "&datasetType=" + datasetType,
                                     handler,
                                     null);            
}

function primaryDatasetTypingDone (type, args, me)
{
    datasetName = args[0].inputElement.value;
    datasetSelectionHandler.argument = {
        inputElement: args[0].inputElement,
        dataset: datasetName
    };
    setDataset ("primary", datasetName, args[0].entryId, datasetSelectionHandler);
}

function inputDatasetTypingDone (type, args, me)
{
    datasetName = args[0].inputElement.value;
    datasetSelectionHandler.argument = {
        inputElement: args[0].inputElement,
        dataset: datasetName
    };

    setDataset ("input", datasetName, args[0].entryId, datasetSelectionHandler);
}

// TODO: make it a method of WorkflowBrowserEntry
function datasetSelectionMade (type, args, me)
{
    me.inputElement.value = args;
    datasetSelectionHandler.argument = {
        inputElement: me.inputElement,
        dataset: args
    };    
    if (typeof(args) == typeof ([]))
    {
        args = args[0];
    }

    setDataset ("primary", args, me.entryId, datasetSelectionHandler);
}

var datasetSelectionHandler = {
    success: function (o) {
        var inputElement = o.argument["inputElement"];
        var dataset = o.argument["dataset"];
        if (dataset === "")
        {
            dataset = "None";
        }
        inputElement.value = dataset;
    },
    failure: cannotConnectToServerAlert
};

function pileupDatasetTypingDone (type, args, me)
{
    datasetName = args[0].inputElement.value;
    datasetSelectionHandler.argument = {
        inputElement: args[0].inputElement,
        dataset: datasetName
    };

    setDataset ("input", datasetName, args[0].entryId, datasetSelectionHandler);
};

function pileupDatasetSelectionMade (type, args, me)
{
    me.inputElement.value = args;
    datasetSelectionHandler.argument = {
        inputElement: me.inputElement,
        dataset: args
    };
    
    if (typeof(args) == typeof ([]))
    {
        args = args[0];
    }

    setDataset ("pileup", args, me.entryId, datasetSelectionHandler);
};

function inputDatasetSelectionMade (type, args, me)
{
    me.inputElement.value = args;
    datasetSelectionHandler.argument = {
        inputElement: me.inputElement,
        dataset: args
    };
    
    if (typeof(args) == typeof ([]))
    {
        args = args[0];
    }
    
    setDataset ("input", args, me.entryId, datasetSelectionHandler);
};



YAHOO.prodrequest.WorkflowBrowserEntry = function (el, userConfig) {
    if (arguments.length > 0) { 
        YAHOO.prodrequest.WorkflowBrowserEntry.superclass.constructor.call(this, el, userConfig); 
    }     
};

YAHOO.extend (YAHOO.prodrequest.WorkflowBrowserEntry, YAHOO.widget.Module); 
YAHOO.prodrequest.WorkflowBrowserEntry.CSS_WORKFLOW_BROWSER_ENTRY = "workflowEntry";
YAHOO.prodrequest.WorkflowBrowserEntry.HEADER_HTML = '' +
'<span class="CloseButton"><img src="../Studio/images/close-button.png"/></span><span class="PsetName"></span>' +
'' +
''+ 
'';

YAHOO.prodrequest.WorkflowBrowserEntry.BODY_HTML = '<div>' +
'<div><label>Primary dataset:</label><span class="PrimaryDataset"></span></div>' +
'<div><label>Input dataset:</label><span class="InputDataset"></span></div>' +
'<div><span class="PileUpDataset"><span class="PileUpDatasetLabel">Pile up:&nbsp;</span></span></div>' +
'<div><span class="EventsNumber"><span class="EventsNumberLabel">Number of events:&nbsp;</span></span></div>' +
'<div><span class="SelectionEfficiency"><span class="SelectionEfficiencyLabel">Generator selection efficiency:&nbsp;</span></span></div>' +
'<div><span class="CrossSection"><span class="CrossSectionLabel">Cross section (pb):&nbsp;</span></span></div>' +
'<div><label>Priority:&nbsp;</label><span class="Priority"><select class="SelectPriority" name="priority">' +
'<option value="20">Low priority</option>' +
'<option selected value="50">Normal priority</option>' +
'<option value="80">High priority</option>' +
'</select></span></div>' +
'<div><span><span>CMSSW version: </span><select class="SelectCMSSWVersion"></select></span></div>' +
'<div><span><span>Associated CMS Group: </span><select class="SelectPGroup"></select></span></div>' +
'</div>' +
'<div class="HiddenView" style="display:none;">' +
"<span class='HiddenViewToggler'>Show advanced options</span>" +
"<div class='HiddenControls'>" +
"<ul>" +
'<span class="OutputDataset"><span class="OutputDatasetLabel">Output dataset:</span></span>' +
'<li><span class="LocalDBS"><span class="LocalDBSLabel">Local DBS:&nbsp;</span></span></li>' +
'</div>' +
'</div>';
YAHOO.prodrequest.WorkflowBrowserEntry.FOOTER_HTML = '';

function populateSelector (selector, options, selected)
{
    for (var j = 0; j < options.length; j++)
    {
        var opt = document.createElement ("option");
        opt.value = options[j].value;
        if (opt.value == selected)
        {
            opt.setAttribute ("selected", "1");
        }
        changeText (opt, options[j].label);
        selector.appendChild (opt);
    }
}

var g_physicsGroups = [];
var physic_groups_populator_handler = {
    success: function (o) {
        var response = o.responseXML;
        var groups = response.getElementsByTagName ("group");
        var items = [];
        for (var i = 0; i < groups.length; i++)
        {
            var group = groups[i];
            g_physicsGroups[i] = {label: group.getAttribute ("label"),
                                  value: group.getAttribute ("id")};
        }
    },
    failure: function (o) {
        alert ("Cannot connect to server");
    }
};

var g_cmsswVersions = [];
var cmssw_versions_populator_handler = {
    success: function (o) {
        var response = o.responseXML;
        var projects = response.getElementsByTagName ("project");
        var items = [];
        for (var i = 0; i < projects.length; i++)
        {
            var project = projects[i];
            g_cmsswVersions[i] = {label: project.getAttribute ("name"),
                                  value: project.getAttribute ("id")};
        }
    },
    failure: function (o) {
        alert ("Cannot connect to server");
    }
};

YAHOO.util.Connect.asyncRequest ("GET",
                                 "../ProdRequest/getPhysicsGroups",
                                 physic_groups_populator_handler);

YAHOO.util.Connect.asyncRequest ("GET",
                                 "../ProdRequest/getAvailableProjects",
                                 cmssw_versions_populator_handler);

function addSelector (args)
{
    var name = args.name;
    var element = args.element;
    selector = YAHOO.util.Dom.getElementsByClassName (name, "select", element)[0];
}

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.init = function (el, userConfig)
{
    YAHOO.prodrequest.WorkflowBrowserEntry.superclass.init.call(this, el);  
    
    this.beforeInitEvent.fire(YAHOO.prodrequest.WorkflowBrowserEntry);
    
    if (userConfig) { 
        this.cfg.applyConfig(userConfig, true); 
    }

    YAHOO.util.Dom.addClass (this.element, YAHOO.prodrequest.WorkflowBrowserEntry.CSS_WORKFLOW_BROWSER_ENTRY);
    this.setHeader (YAHOO.prodrequest.WorkflowBrowserEntry.HEADER_HTML);
    this.setBody (YAHOO.prodrequest.WorkflowBrowserEntry.BODY_HTML);
    this.setFooter (YAHOO.prodrequest.WorkflowBrowserEntry.FOOTER_HTML);
    var module = this;
    this.renderEvent.subscribe (function () { 
        var primaryDatasetSpan = YAHOO.util.Dom.getElementsByClassName ("PrimaryDataset", "span", module.element)[0];
        var inputDatasetSpan = YAHOO.util.Dom.getElementsByClassName ("InputDataset", "span", module.element)[0];
        var outputDatasetSpan = YAHOO.util.Dom.getElementsByClassName ("OutputDataset", "span", module.element)[0];
        var pileupDatasetSpan = YAHOO.util.Dom.getElementsByClassName ("PileUpDataset", "span", module.element)[0];
        var localDBSSpan = YAHOO.util.Dom.getElementsByClassName ("LocalDBS", "span", module.element)[0];
        var crossSectionSpan = YAHOO.util.Dom.getElementsByClassName ("CrossSection", "span", module.element)[0];
        var selectionEfficiencySpan = YAHOO.util.Dom.getElementsByClassName ("SelectionEfficiency", "span", module.element)[0];
        var eventsNumberSpan = YAHOO.util.Dom.getElementsByClassName ("EventsNumber", "span", module.element)[0];
        var prioritySelect = YAHOO.util.Dom.getElementsByClassName ("SelectPriority", "select", module.element)[0];
        var physicsGroupSelect = YAHOO.util.Dom.getElementsByClassName ("SelectPGroup", "select", module.element)[0];
        var cmsswVersionSelect = YAHOO.util.Dom.getElementsByClassName ("SelectCMSSWVersion", "select", module.element)[0];
        
        var editableText = new YAHOO.iguana.EditableText (userConfig["primaryDataset"], primaryDatasetSpan);
        var inputDatasetEditableText = new YAHOO.iguana.EditableText (userConfig["inputDataset"], inputDatasetSpan);
        var outputDatasetEditableText = new YAHOO.iguana.EditableText (userConfig["outputDataset"], outputDatasetSpan);
        var pileupDatasetEditableText = new YAHOO.iguana.EditableText (userConfig["pileupDataset"], pileupDatasetSpan);
        var localDBSEditableText = new YAHOO.iguana.EditableText (userConfig["localDBS"], localDBSSpan);
        var crossSectionText = new YAHOO.iguana.EditableText (userConfig["crossSection"], crossSectionSpan);
        var selectionEfficiencyText = new YAHOO.iguana.EditableText (userConfig["selectionEfficiency"], selectionEfficiencySpan);
        var eventsNumeberText = new YAHOO.iguana.EditableText (userConfig["events"], eventsNumberSpan);

        var propertyEditingHandler = {
            success: function (o) {},
            failure: cannotConnectToServerAlert
        };

        function selectChanged ()
        {
            YAHOO.util.Connect.asyncRequest ("GET",
                                             "../ProdRequest/setWorkflowEntryProperty"+
                                             "?entry_id=" + userConfig["entryId"] +
                                             "&key=priority" +
                                             "&value=" + prioritySelect.value,
                                             propertyEditingHandler,
                                             null);

        }

        function cmsswVersionChanged ()
        {
            YAHOO.util.Connect.asyncRequest ("GET",
                                             "../ProdRequest/setWorkflowEntryCMSSWVersion" + 
                                             "?entry_id=" + userConfig["entryId"] +
                                             "&project_id=" + cmsswVersionSelect.value,
                                             propertyEditingHandler,
                                             null);
        }
        
        function physicsGroupChanged () {
            YAHOO.util.Connect.asyncRequest ("GET",
                                             "../ProdRequest/setWorkflowEntryProperty"+
                                             "?entry_id=" + userConfig["entryId"] +
                                             "&key=physics_group" +
                                             "&value=" + physicsGroupSelect.value +
                                             "&value_type=int",
                                             propertyEditingHandler,
                                             null);
        }
        
        YAHOO.util.Event.addListener(prioritySelect, "change", selectChanged); 

        populateSelector (physicsGroupSelect, g_physicsGroups, userConfig["physics_group"]);
        YAHOO.util.Event.addListener(physicsGroupSelect, "change", physicsGroupChanged);         

        populateSelector (cmsswVersionSelect, g_cmsswVersions, userConfig["cmssw_version"]);
        YAHOO.util.Event.addListener(cmsswVersionSelect, "change", cmsswVersionChanged);

        editableText.entryId = userConfig["entryId"];
        editableText.aboutDone.subscribe (primaryDatasetTypingDone);
        
        crossSectionText.entryId = userConfig["entryId"];
        crossSectionText.key = "cross_section";
        crossSectionText.value_type = "float";
        crossSectionText.aboutDone.subscribe (propertyTypingDone);

        selectionEfficiencyText.entryId = userConfig["entryId"];
        selectionEfficiencyText.key = "selection_efficiency";
        selectionEfficiencyText.value_type = "float";
        selectionEfficiencyText.aboutDone.subscribe (propertyTypingDone);
        
        eventsNumeberText.entryId = userConfig["entryId"];
        eventsNumeberText.key = "requested_events";
        eventsNumeberText.value_type = "int";
        eventsNumeberText.aboutDone.subscribe (propertyTypingDone);
        
        var suggestionSelector = new YAHOO.iguana.SuggestionSelector (editableText, dbsSuggestions);
        suggestionSelector.choiceMade.subscribe (datasetSelectionMade, editableText);
        
        // Contoller for the pileup dataset.
        pileupDatasetEditableText.entryId = userConfig["entryId"];
        pileupDatasetEditableText.aboutDone.subscribe (pileupDatasetTypingDone);
        var pileupSuggestionSelector = new YAHOO.iguana.SuggestionSelector (pileupDatasetEditableText, dbsSuggestions);
        pileupSuggestionSelector.choiceMade.subscribe (pileupDatasetSelectionMade, pileupDatasetEditableText);

        // Contoller for the input dataset.
        inputDatasetEditableText.entryId = userConfig["entryId"];
        inputDatasetEditableText.aboutDone.subscribe (inputDatasetTypingDone);
        var inputDatasetSuggestionSelector = new YAHOO.iguana.SuggestionSelector (inputDatasetEditableText, inputDatasetSuggestions);
        inputDatasetSuggestionSelector.choiceMade.subscribe (inputDatasetSelectionMade, inputDatasetEditableText);
        inputDatasetSuggestionSelector.primaryDatasetText = editableText;

        //Close button
        var closeButton = YAHOO.util.Dom.getElementsByClassName ("CloseButton", "span", module.element)[0];
        YAHOO.util.Event.addListener (closeButton, "mousedown", module.destroy, module);

        //Advanced view button
        var toggleButton = YAHOO.util.Dom.getElementsByClassName ("HiddenViewToggler", "span", module.element)[0];
        YAHOO.util.Event.addListener (toggleButton, 
                                      "mousedown", 
                                      YAHOO.prodrequest.WorkflowBrowserEntry.prototype.toggleAdvancedOptions, module);
        // Tooltips
        var primaryDatasetTooltip = new YAHOO.widget.Tooltip("primaryDatasetTooltip", {
                context:editableText.textElement,  
                text:"Click to edit primary dataset.", 
                showDelay:500 } );

        var inputDatasetTooltip = new YAHOO.widget.Tooltip("inputDatasetTooltip", {
                context:inputDatasetEditableText.textElement,  
                text:"Click to edit input dataset.", 
                showDelay:500 } );

        var pileupDatasetTooltip = new YAHOO.widget.Tooltip("pileupDatasetTooltip", {
                context:pileupDatasetEditableText.textElement,  
                text:"Click to edit pile-up dataset.", 
                showDelay:500 } );

        var localDBSTT = new YAHOO.widget.Tooltip("localDBSTT", {
                context:localDBSEditableText.textElement,  
                text:"Not implemented yet.", 
                showDelay:500 } );
        
        var crossSectionTT = new YAHOO.widget.Tooltip ("crossSectionTooltip", {
                context: crossSectionText.textElement,
                text: "Click to edit sample cross section",
                showDelay:500} );

        var selectionEfficiencyTT = new YAHOO.widget.Tooltip ("selectionEfficiencyTooltip", {
                context: selectionEfficiencyText.textElement,
                text: "Click to edit generator selection efficiency",
                showDelay:500} );
    });
};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.destroyHanlder = {
    //FIXME: this should properly delete the entry.
    success: function (o) {o.argument.hide ();},
    failure: function (o) {alert ("Cannot delete entry");}
};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.destroy = function (evt, obj) {
    var id = obj.cfg.getProperty ("entryId");
    YAHOO.prodrequest.WorkflowBrowserEntry.prototype.destroyHanlder["argument"] = obj;
    YAHOO.util.Connect.asyncRequest ("get",
                                     "../ProdRequest/destroyWorkflowEntry?entry_id=" + id,
                                     YAHOO.prodrequest.WorkflowBrowserEntry.prototype.destroyHanlder,
                                     null);
};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.initDefaultConfig = function ( ){
    YAHOO.prodrequest.WorkflowBrowserEntry.superclass.initDefaultConfig.call (this);
    this.cfg.addProperty ("psetName", {handler:this.configPsetName, suppressEvent: true});
    this.cfg.addProperty ("entryId", {handler:this.configEntryId, suppressEvent: true});
    this.cfg.addProperty ("primaryDataset", {handler:this.configPrimaryDataset, suppressEvent:true});
    this.cfg.addProperty ("inputDataset", {handler:this.configInputDataset, suppressEvent:true});
    this.cfg.addProperty ("outputDataset", {handler:this.configOutputDataset, suppressEvent:true});
    this.cfg.addProperty ("pileupDataset", {handler:this.configPileupDataset, suppressEvent:true});
    this.cfg.addProperty ("localDBS", {handler:this.configPileupDataset, suppressEvent:true});
    this.cfg.addProperty ("selectionEfficiency", {handler:this.configSelectionEfficiency, suppressEvent:true});
    this.cfg.addProperty ("crossSection", {handler:this.configCrossSection, suppressEvent:true});
    this.cfg.addProperty ("eventsNumber", {handler:this.configEventsNumber, suppressEvent:true});
    this.cfg.addProperty ("priority", {handler:this.configPriority, suppressEvent:true});
    this.cfg.addProperty ("physicsGroup", {handler:this.configPhysicsGroup, suppressEvent:true});
    this.cfg.addProperty ("cmsswVersion", {handler:this.configCMSSWVersion, suppressEvent:true});
    this.cfg.addProperty ("collapsed", {handler:this.configCollapsed, suppressEvent:true});
    this.cfg.queueProperty ("collapsed", "true");
    this.cfg.queueProperty ("pileupDataset", "None");
    this.cfg.queueProperty ("localDBS", "Click to add");
    this.cfg.queueProperty ("selectionEfficiency", "1.0");
    this.cfg.queueProperty ("crossSection", "undefined");
    this.cfg.queueProperty ("eventsNumber", "1000");
    this.cfg.queueProperty ("priority", "50");
    this.cfg.queueProperty ("physicsGroup", "1");
};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configPsetName = function (type, args, obj)
{
    var psetName = args[0];
    var psetNameSpan = YAHOO.util.Dom.getElementsByClassName ("PsetName", "span", this.element)[0];
    changeText (psetNameSpan, psetName);
};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configEntryId = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configPrimaryDataset = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configInputDataset = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configOutputDataset = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configPileupDataset = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configSelectionEfficiency = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configCrossSection = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configEventsNumber = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configPhysicsGroup = function (type, args, obj) {};
YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configCMSSWVersion = function (type, args, obj) {};

YAHOO.prodrequest.WorkflowBrowserEntry.prototype.configCollapsed = function (type, args, obj) {
    var divToBeHidden = YAHOO.util.Dom.getElementsByClassName ("HiddenControls", "div", obj.element)[0];
    var toggler = YAHOO.util.Dom.getElementsByClassName ("HiddenViewToggler", "span", this.element)[0];
    if (args[0])
    {
        YAHOO.util.Dom.setStyle (divToBeHidden, "display", "none");        
        changeText (toggler, "Show advanced options");
    }
    else
    {
        YAHOO.util.Dom.setStyle (divToBeHidden, "display", "block");
        changeText (toggler, "Hide advanced options");
    }
};


YAHOO.prodrequest.WorkflowBrowserEntry.prototype.toggleAdvancedOptions = function (e, obj) {
    var collapsed = ! obj.cfg.getProperty ("collapsed");
    obj.cfg.setProperty ("collapsed", collapsed);
};
