from ProdRequestCommon.DataBase.ProdRequestApi import ProdRequestApi
from ProdRequestCommon.DataBase.ProdRequestApi import QueryMaker
from Framework import Controller
from Framework.PluginManager import DeclarePlugin
import cherrypy
from cherrypy import *

def _sanitize (string):
  return string.replace ("'", "").replace ('"', '')

def json (func):
  def wrapper (self, *args, **kwds):
      funcName = func.__name__
      data = func (self, *args, **kwds)
      cherrypy.response.headers['Content-Length'] = str (len (data))
      cherrypy.response.headers['Content-Type'] = "application/x-json"
      return str (data)
  wrapper.__doc__ = func.__doc__
  wrapper.__name__ = func.__name__
  wrapper.exposed = True
  return wrapper


class ProdRequestBackend (Controller):
  def __init__ (self, context):
    Controller.__init__(self, context, __file__)
    self.api = ProdRequestApi()
  
  def readyToRun (self):
    self.api.connect ("prodrequest_new.db", "sqlite")
  
  @expose
  def helloWorld (self, *args, **kwds):
    return "Hello World"

  @json
  @expose
  def layout (self, label, *args, **kwds):
    return "{query: '%(query)s'}" % self.api.getDataObject ("query", 
            """SELECT rw.query FROM request_view rw WHERE rw.label = :label""", 
            label)[0]

  @expose
  def request (self, *args, **kwds):
    q = (kwds.has_key ("q") and kwds["q"]) or ""
    o = (kwds.has_key ("o") and kwds["o"]) or ""
    l = (kwds.has_key ("l") and kwds["l"]) or ""
    off = (kwds.has_key ("off") and kwds["off"]) or ""
    maker = QueryMaker ("request")
    for arg in args:
      maker.addField (_sanitize(arg))
    for condition in q.strip (";").split (";"):
      if condition: maker.addConditionByString (_sanitize(condition))
    for ordering in o.split (","):
      if ordering: maker.addOrdering (_sanitize (ordering))
    try:
      entries = self.api.getDataTable (maker.createQuery (limit=l, offset=off), 
                                       maker.bindings ())
    except:
      return "<html><body>The previous query:\n<pre>\n\n%s\n\n</pre>returned an error<body></html>" % maker.createQuery (limit=l, offset=off)
    results = []
    for row in entries:
      results.append ([cell for cell in row])
    final = {"entries": results}
    return repr (final).replace (" u'", "'")
    
DeclarePlugin ("/Controllers/ProdRequest/Backend", ProdRequestBackend, {"baseUrl": "/ProdRequestBackend"})
