from Framework.Controller import Controller, require_args
from Framework import templateXML
from ProdRequestCommon.MonitoringCore.GlobalHistory import GlobalHistory
from ProdRequestCommon.MonitoringCore.PhysicsGroupHistory import PhysicsGroupHistory 
from Framework.PluginManager import DeclarePlugin
from cherrypy import expose


class ProdRequestMonitoring (Controller):
    def __init__ (self, context):
        Controller.__init__ (self, context, __file__)
    
    @templateXML
    def globalStatus (self):
        entries = GlobalHistory.select ().orderBy("timestamp").reversed ()[0:10]
        return {'entries': entries}

    def atomFeedError (self):
        return self.templatePage ("atomError", {})
        
    @expose
    @require_args ("physics_group", onFail=lambda self : self.atomFeedError ())
    def physicsGroupStatus (self, physics_group, *args, **kwds):
        physics_group = int (physics_group)
        entries = PhysicsGroupHistory.select ((PhysicsGroupHistory.q.physics_group == physics_group)).orderBy("harvest_time").reversed()[0:10]
        return self.templatePage ("physicsGroupStatus", {'entries': entries, 'physics_group': physics_group})

DeclarePlugin ("/Controllers/ProdRequest/Monitoring", ProdRequestMonitoring, {"baseUrl": "/ProdRequestMonitoring"})
