import os
import sys
import getopt
import popen2
import time


# Fixme: do the same for createProdWorkflow
def createPreProdWorkflow (PyCfg = None,
                           PSetHash = None,
                           prodName = None,
                           cmsswVersion = None,
                           category = "PreProd",
                           timestamp = int(time.time()),
                           FakeHash = False,
                           pileupDS = None,
                           pileupFilesPerJob = 1,
                           dbsAddress = None,
                           dbsUrl = None,
                           dlsAddress = None,
                           dlsType = None,
                           pileupSkipLocation = False):
    spec = WorkflowSpec()
    spec.setWorkflowName(prodName)
    spec.setRequestCategory(category)
    spec.setRequestTimestamp(timestamp)
    
    # //
    # // This value was created by running the EdmConfigHash tool
    # //  on the original cfg file.
    
    
    cmsRun = spec.payload
    cmsRun.name = "cmsRun1" # every node in the workflow needs a unique name
    cmsRun.type = "CMSSW"   # Nodes that are CMSSW based should set the name
    cmsRun.application["Project"] = "CMSSW" # project
    cmsRun.application["Version"] = cmsswVersion # version
    cmsRun.application["Architecture"] = "slc3_ia32_gcc323" # arch (not needed)
    cmsRun.application["Executable"] = "cmsRun" # binary name
    cmsRun.configuration = PyCfg # Python PSet file
    
    
    # //
    # // Pileup sample?
    # //
    if pileupDS != None:
        puPrimary = pileupDS.split("/")[1]
        puTier = pileupDS.split("/")[2]
        puProc = pileupDS.split("/")[3]
        puDataset = cmsRun.addPileupDataset(puPrimary, puTier, puProc)
        puDataset['FilesPerJob'] = pileupFilesPerJob
        if customDBSDLS:
            puDataset['DBSAddress'] = dbsAddress
            puDataset['DBSURL'] = dbsUrl
            puDataset['DLSType'] = dlsType
            puDataset['DLSAddress'] = dlsAddress
        if pileupSkipLocation:
            puDataset['SkipLocation'] = pileupSkipLocation 
    
    #  //
    # // Pull all the output modules from the configuration file,
    #//  treat the output module name as DataTier and AppFamily,
    #  //since there isnt a standard way to derive these things yet.
    # //    
    #//  For each module a dataset declaration is created in the spec
    cfgInt = CfgInterface(cmsRun.configuration, True)
    datasetList = []
    for outModName, val in cfgInt.outputModules.items():
        #  //
        # // Check for Multi Tiers.
        #//  If Output module contains - characters, we split based on it
        #  //And create a different tier for each basic tier
        # //
        #//
    
        tierList = splitMultiTier(outModName)    
        for dataTier in tierList:
            processedDS = "%s-%s-%s-unmerged" % (
                cmsRun.application['Version'], outModName, timestamp)
            outDS = cmsRun.addOutputDataset(prodName, 
                                            processedDS,
                                            outModName)
    
            outDS['DataTier'] = dataTier
            outDS["ApplicationName"] = cmsRun.application["Executable"]
            outDS["ApplicationProject"] = cmsRun.application["Project"]
            outDS["ApplicationVersion"] = cmsRun.application["Version"]
            outDS["ApplicationFamily"] = outModName
            if FakeHash:
                guid = MCPayloadsUUID.uuidgen()
                if guid == None:
                    guid = MCPayloadsUUID.uuid()
                hashValue = "hash=%s;guid=%s" % (PSetHash, guid)
                outDS['PSetHash'] = hashValue
            else:
                outDS['PSetHash'] = PSetHash
            datasetList.append(outDS.name())
    
    stageOut = cmsRun.newNode("stageOut1")
    stageOut.type = "StageOut"
    stageOut.application["Project"] = ""
    stageOut.application["Version"] = ""
    stageOut.application["Architecture"] = ""
    stageOut.application["Executable"] = "RuntimeStageOut.py" # binary name
    stageOut.configuration = ""
    
    mergedLFNBase(spec)
    unmergedLFNBase(spec)
    
    return spec
