from Framework import Controller
from cherrypy import expose
from Framework import templatepage
from Framework import availableApplications
from Tools.SecurityModuleCore import SecurityToken
from os import listdir
from Framework.PluginManager import DeclarePlugin

class TestService (object):
    def __init__ (self):
        self.__tests = []
        self.__requirements = {}
        setattr (self, "tests", lambda : self.__tests)
        setattr (self, "requirements", lambda : self.__requirements.keys ())
    
    def addTestPath (self, path):
        for test in listdir (path):
            try:
                if test.rsplit(".",1)[1] != "js":
                    continue
                name = test.rsplit ("_",1)[1].rsplit (".", 1)[0]
                url = test
                module = path.rsplit ("/", 2)[1]
                self.__tests.append ({'name': name, 'url': url, 'module': module})
            except IndexError, e:
                print e

    def addRequirements (self, requirements):
        if type (requirements) == type (str ()):
            requirements = [requirements]
        for requirement in requirements:
            self.__requirements[requirement] = 1


class Studio (Controller):
    def __init__ (self, context):
        Controller.__init__ (self, context, __file__)
        context.addService (TestService ())
    
    def readyToRun (self):
        self.context.TestService ().addTestPath (__file__.rsplit ("/", 1)[0] + "/jstest")
    
    @expose
    def index (self):
        return "IGUANA Studio controller V2.0"
    
    @templatepage
    def login (self):
        return {'redirect': '../Studio/initSession',
                'demo': False}
    @templatepage
    def logout (self):
        return {'proxy': ''}
    
    @templatepage
    def launch (self, **args):
        return {'redirect': args["script"],
                'demo': ''}
    
    # TODO: add check for the useragent
    # TODO: add idCookie
    @templatepage
    def initSession (self):
        token = SecurityToken ()
        print "available applications:" + str(availableApplications)
        return {'applications': availableApplications,
                'proxy': '',
                'idCookie': '',
                'dn': token.dn,
                'validUserAgent': True,
                'userAgent': "Netscape"}
    @templatepage
    def testJavascript (self, **args):
        if not args.has_key ("testFile"):
            return {'funcName': 'noTest',
                    'testFile': ''}
        testFile = args["testFile"]
        if not args.has_key("funcName"):
            funcName = testFile.rsplit (".", 1)[0]
        else:
            funcName = args["funcName"]
        return {'funcName': funcName,
                'testFile': testFile,
                'module': args["module"],
                'requirements': self.context.TestService ().requirements}
    
    @templatepage
    def getTestPage (self):
        return {'tests': self.context.TestService ().tests}

DeclarePlugin ("/Controllers/Bonsai/Studio", Studio, {"baseUrl": "/Studio"})