YAHOO.namespace ("iguana");

YAHOO.iguana.EditableText = function (initialValue, parent, doneCallback)
{
    this.doneCallback = doneCallback;
    this.textElement = document.createElement ("span");
    this.inputSpan = document.createElement ("span");
    this.inputElement = document.createElement ("input");
    this.initalValue = initialValue;
    this.inputElement.value = initialValue;
    this.inputSpan.appendChild (this.inputElement);
    changeText (this.textElement, initialValue);
    this.inputSpan.style["display"] = "none";
    YAHOO.util.Dom.addClass (this.textElement, "EditableText");
    parent.appendChild (this.textElement);
    parent.appendChild (this.inputSpan);
    YAHOO.util.Event.addListener (this.textElement, "click", this.onClick, this);
    YAHOO.util.Event.addListener (this.inputElement, "blur", this._onBlurForwarder, this);
    YAHOO.util.Event.addListener (this.inputElement, "keyup", this._onKeyUpForwarder, this);
    this.delayedEdit = new YAHOO.util.CustomEvent ("delayedEdit", this);
    this.aboutDone = new YAHOO.util.CustomEvent ("aboutDone", this);
    this.blur = new YAHOO.util.CustomEvent ("blur", this);
    this.editingInProgress = new YAHOO.util.CustomEvent ("editingInProgress", this);
    this.returnPressed = new YAHOO.util.CustomEvent ("returnPressed", this);
    this.arrowMovement = new YAHOO.util.CustomEvent ("arrowMovement", this);
    this.editingAborted = new YAHOO.util.CustomEvent ("editingAborted", this);
    this.delayedEditTimer = null;
}

YAHOO.iguana.EditableText.prototype._onBlurForwarder = function (evt, obj)
{
    YAHOO.util.Event.preventDefault (evt);    
    YAHOO.util.Event.stopPropagation (evt);    

    this.unsubscribeAll ();
    this.aboutDone.fire (this);
    this.onAboutDone ("noargs", this);
    this.blur.fire ();
    return;
}

YAHOO.iguana.EditableText.prototype._onKeyUpForwarder = function (evt, obj)
{
    YAHOO.util.Event.preventDefault (evt);
    if (evt.keyCode == 38 || evt.keyCode == 40)
    {
        obj.arrowMovement.fire (evt);
    }
    else if (evt.keyCode == 13)
    {
        obj.returnPressed.fire ();
    }
    else if (evt.keyCode == 27)
    {
        obj.editingAborted.fire ();
        obj.done (false);
    }
    else
    {
        obj.editingInProgress.fire (evt);
    }
}


YAHOO.iguana.EditableText.prototype.onClick = function (evt, obj)
{
    obj.inputSpan.style["display"] = "inline";
    obj.textElement.style["display"] = "none"; 
    obj.inputElement.focus ();
    obj.subscribeAll ();
}

YAHOO.iguana.EditableText.prototype.editingDone = function (value)
{
    YAHOO.iguana.EditableText.prototype.currentlyModifiedObject.delayedEdit.fire (value);
}

YAHOO.iguana.EditableText.prototype.unsubscribeAll = function ()
{
    this.editingInProgress.unsubscribe (this.onEditiongInProgress);
    this.blur.unsubscribe (this.onAboutDone);
    this.returnPressed.unsubscribe (this.onReturnPressed);
}

YAHOO.iguana.EditableText.prototype.subscribeAll = function ()
{
    this.editingInProgress.subscribe (this.onEditiongInProgress, this);
    this.blur.subscribe (this.onAboutDone, this);
    this.returnPressed.subscribe (this.onReturnPressed, this);
}


YAHOO.iguana.EditableText.prototype.onReturnPressed = function (type, args, me)
{
    this.unsubscribeAll ();
    this.aboutDone.fire (this);
    this.onAboutDone ("noargs", this);
    return;
}

YAHOO.iguana.EditableText.prototype.onEditiongInProgress = function (type, args, me)
{
    if (this.delayedEditTimer)
    {
        clearTimeout (this.delayedEditTimer);
    }
    YAHOO.iguana.EditableText.prototype.currentlyModifiedObject = this;
    this.delayedEditTimer = setTimeout ("YAHOO.iguana.EditableText.prototype.editingDone (\'" + this.inputElement.value + "\')", 1000);
}

YAHOO.iguana.EditableText.prototype.done = function (isDone)
{
    if (isDone)
    {
        if (this.inputElement.value == "")
        {
            this.inputElement.value = "None";
        }
        changeText (this.textElement, this.inputElement.value);
    }
    else{
        this.inputElement.value = this.initialValue;
    }
    this.inputSpan.style["display"] = "none";
    this.textElement.style["display"] = "inline";     
}

YAHOO.iguana.EditableText.prototype.onAboutDone = function (type, args, me)
{
    this.unsubscribeAll ();
    var isDone = false;    
    if (this.doneCallback) {
        isDone = this.doneCallback (this);
    }
    else {
        this.done (true);
    }
}
