YAHOO.namespace ("iguana");

YAHOO.iguana.SuggestionSelector = function (delayableTextInput, choicesCallback)
{
    this.overlayModule = YAHOO.iguana.createEmptyOverlay (document.body, "SuggestionSelector");
    this.choicesCallback = choicesCallback;
    this.MAX_CHOICES = 10;
    this.currentSelection = -1;
    this.isSelecting = false;
    this.suggestions = [];
    this.delayableTextInput = delayableTextInput;
    delayableTextInput.delayedEdit.subscribe (this.onQueryUpdated, this);
    delayableTextInput.aboutDone.subscribe (this.onEditingDone, this);
    delayableTextInput.arrowMovement.subscribe (this.onSelectionChange, this);
    delayableTextInput.returnPressed.subscribe (this.onReturnPressed, this);
    delayableTextInput.blur.subscribe (this.onBlur, this);
    delayableTextInput.editingAborted.subscribe (this.onEditingDone, this);
    this.choiceMade = new YAHOO.util.CustomEvent ("choiceMade", this);
}

function showOverlay (overlay, textItem)
{
    var pos = YAHOO.util.Dom.getXY (textItem.inputElement);
    overlay.moveTo (pos[0], pos[1] + 20);
    overlay.show ();
}

YAHOO.iguana.SuggestionSelector.prototype.onEditingDone = function (type, args, me)
{
    me.overlayModule.hide ();
    me.isSelecting = false;
}

YAHOO.iguana.SuggestionSelector.prototype.onBlur = function (type, args, me)
{
    me.overlayModule.hide ();
    me.isSelecting = false;
}

YAHOO.iguana.SuggestionSelector.prototype.onQueryUpdated = function (type, args, me)
{
    me.currentSelection = -1;
    showOverlay (me.overlayModule, me.delayableTextInput)
    me.choicesCallback (args, me);
}

YAHOO.iguana.SuggestionSelector.prototype.updateSuggestions = function (suggestions)
{
    var selectionList = YAHOO.util.Dom.getElementsByClassName("SuggestionSelector", "div", this.overlayModule.element)[0];
    YAHOO.iguana.removeAllChildren (selectionList);
    this.suggestions = suggestions;
    for (i = 0; i < suggestions.length; i++)
    {
        var newElement = document.createElement ("div");
        changeText (newElement, suggestions[i]);
        selectionList.appendChild (newElement);
    }
}

YAHOO.iguana.SuggestionSelector.prototype.onReturnPressed = function (type, args, me)
{
    me.overlayModule.hide ();
    // Is this the actual behavior we want???
    if (me.isSelecting == true)
        me.choiceMade.fire (me.suggestions[me.currentSelection]);
    me.isSelecting = false;
    return;    
}

YAHOO.iguana.SuggestionSelector.prototype.onSelectionChange = function (type, args, me)
{
    keystroke = args[0].keyCode;
    var ARROW_UP = 38;
    var ARROW_DOWN = 40;

    me.isSelecting = true;

    if (me.isSelecting == false)
    {
        showOverlay (me.overlayModule, me.delayableTextInput);
        me.choicesCallback (this.inputElement.value, this);
    }
    
    var selectionList = YAHOO.util.Dom.getElementsByClassName("SuggestionSelector", "div", me.overlayModule.element)[0];
    var maxChoices = (me.MAX_CHOICES < selectionList.childNodes.length) ? me.MAX_CHOICES : selectionList.childNodes.length-1; 

    if (me.currentSelection >= 0)
    {
        YAHOO.util.Dom.removeClass (selectionList.childNodes[me.currentSelection], "selected"); 
    }
    
    var nextSelection = me.currentSelection;
    
    if (keystroke == ARROW_UP)
    {
        nextSelection -= 1;
        me.isSelecting = true;
        me.currentSelection = (nextSelection  >= 0 ) ? nextSelection : 0;
    }
    
    if (keystroke == ARROW_DOWN)
    {
        nextSelection += 1;
        me.isSelecting = true;
        me.currentSelection = (nextSelection <= maxChoices) ? nextSelection : maxChoices;
    }
    YAHOO.util.Dom.addClass (selectionList.childNodes[me.currentSelection], "selected");
}

YAHOO.iguana.SuggestionSelector.prototype.suggestionDone = function ()
{
    this.overlayModule.hide ();
    this.isSelecting = false;
}