from Framework.PluginManager import DeclarePlugin
from ProdRequestCommon.ProdCommonCore import ProdCommonPlugin

def setEnvironment (arch, version):
    return """export BASE=/afs/cern.ch/cms/sw/slc3_ia32_gcc323;
              export PYTHONPATH=$BASE/cms/cmssw/%(version)s/python:$PYTHONPATH;
              export CMSSW_SEARCH_PATH=$BASE/cms/cmssw/%(version)s/src:$BASE/cms/cmssw/%(version)s/share;
              export CMSSW_BASE=$BASE/cms/cmssw/%(version)s;
              export PATH=$CMSSW_BASE/bin/slc3_ia32_gcc323:$PATH;
              export LD_LIBRARY_PATH=$CMSSW_BASE/lib/slc3_ia32_gcc323:$CMSSW_BASE/external/slc3_ia32_gcc323/lib:$CMSSW_BASE/external/slc3_ia32_gcc323/lib01:$LD_LIBRARY_PATH""" % locals ()


def unsetEnvironment (arch, version):
    pass
 

DeclarePlugin ("/ProdRequest/ProdCommonPlugins/PRODCOMMON_0_3_X", ProdCommonPlugin, {"initFile":"../../prodcommon/PRODCOMMON_0_3_1-wt/etc/profile.d/init.sh", 
                                                                           "pluginLocation": __file__,
                                                                           "setEnvironment": setEnvironment,
                                                                           "unsetEnvironment": unsetEnvironment})
