from Framework.PluginManager import DeclarePlugin
from ProdRequestCommon.ProdCommonCore import ProdCommonPlugin
from os import environ

def setEnvironment (arch, version):
    return """export BASE=/afs/cern.ch/cms/sw/slc4_ia32_gcc345;
              export PYTHONPATH=$BASE/cms/cmssw/%(version)s/python:$PYTHONPATH;
              export CMSSW_SEARCH_PATH=$BASE/cms/cmssw/%(version)s/src:$BASE/cms/cmssw/%(version)s/share;
              export CMSSW_BASE=$BASE/cms/cmssw/%(version)s""" % locals ()


def unsetEnvironment (arch, version):
    pass
    
DeclarePlugin ("/ProdRequest/ProdCommonPlugins/PRODCOMMON_0_4_X_ALPGEN", ProdCommonPlugin, {"initFile":"../../prodcommon/PRODCOMMON_0_4_0_pre2-wt/etc/profile.d/init.sh", 
                                                                           "pluginLocation": __file__, 
                                                                           "setEnvironment": setEnvironment,
                                                                           "unsetEnvironment": unsetEnvironment})
