from Framework.PluginManager import DeclarePlugin
from ProdRequestCommon.ProdCommonCore import ProdCommonPlugin
from os import environ

def setEnvironment (arch, version):
    return """export SCRAM_ARCH=slc3_ia32_gcc323;export BUILD_ARCH=slc3_ia32_gcc323;
              export BASE=/afs/cern.ch/cms/sw/slc3_ia32_gcc323;
              export PYTHONPATH=$BASE/cms/cmssw/%(version)s/python:$PYTHONPATH;
              export CMSSW_SEARCH_PATH=$BASE/cms/cmssw/%(version)s/src:$BASE/cms/cmssw/%(version)s/share;
              export CMSSW_BASE=$BASE/cms/cmssw/%(version)s;
              export CURRENT_DIR=`pwd`;cd $CMSSW_BASE;eval `scramv1 run -sh`;cd $CURRENT_DIR""" % locals ()


def unsetEnvironment (arch, version):
    pass
    
DeclarePlugin ("/ProdRequest/ProdCommonPlugins/PRODCOMMON_0_5_X_ALPGEN", ProdCommonPlugin, {"initFile":"../../prodcommon/PRODCOMMON_0_5_6-wt/etc/profile.d/init.sh", 
                                                                           "pluginLocation": __file__, 
                                                                           "setEnvironment": setEnvironment,
                                                                           "unsetEnvironment": unsetEnvironment})
