"""
Service to load the SecurityModule into the context of other applications
"""

from Tools.SecurityModuleCore.SecurityDBApi import SecurityDBApi
from Framework.PluginManager import DeclarePlugin
from Framework.Context import Context
from Framework.Logger import Logger

class SecurityModuleService (object):
    def __init__ (self, context):
        childContext = Context (context)
        childContext.addService (Logger ("SecurityDBApi"))
        context.addService (SecurityDBApi (childContext))

DeclarePlugin ("/Services/SecurityModuleService", SecurityModuleService ,{})