import cherrypy
from sqlobject import *
from sqlobject.sqlite.sqliteconnection import SQLiteConnection
try:
    from sqlobject.mysql.mysqlconnection import MySQLConnection
except:
    def MySQLConnection (url, **__kw):
        raise "Connection kind not supported %s " % url 
        
import os.path

class DataBase (object):
    def __init__ (self, dbName, **kw):
        self.dbName = dbName
        self.conn = dbconnection.ConnectionHub ()
        self.db_filename = os.path.abspath (self.dbName)
        self.dbOpt = kw
        def connect (threadIndex):
            self.conn.threadConnection = self.createConnection (**kw)
        cherrypy.engine.on_start_thread_list.append (connect)
    
    def connect (self):
        self.conn.threadConnection = self.createConnection (**self.dbOpt)
    
    def createConnection (self, **kw):
        if (not kw.keys ()) or (kw["type"] == "sqlite"):
            return SQLiteConnection (self.dbName)
        if kw["type"] == "mysql":
            return MySQLConnection (db=self.dbName, 
                                    host=kw["host"], 
                                    port=kw["port"],
                                    user=kw["user"],
                                    passwd=kw["passwd"])
    
def clear_cache (*tables):
    def decorator (func):
        def wrapper (self, *args, **kwds):
            for table in tables:
                table._connection.cache.clear ()
            return func (self, *args, **kwds)
        wrapper.__name__ = func.__name__
        wrapper.__doc__ = func.__doc__
        return wrapper
    return decorator
