from ProdRequestCommon.MonitoringCore import MonitoringCore
from Framework.Context import Context
from Framework.Logger import Logger
from Tools.SecurityModuleCore.SecurityDBApi import SecurityDBApi

context = Context ()
context.addService (Logger ("test_Monitoring01"))
security_api = SecurityDBApi (context)
monitoringCore = MonitoringCore (context)
monitoringCore.harvestStats ()

historyObject = monitoringCore.getGlobalProductionStatus ()

print "ProdRequest global stats on %s" % historyObject.timestamp
print "Requested events %s" % historyObject.requested_events
print "Running events %s" % historyObject.running_events
print "Completed events %s" % historyObject.done_events

userObject = monitoringCore.getUserProductionStatus (1)
userInfo = security_api.getAllFromID (1)
print "ProdRequest user %s stats on %s" % (userInfo, userObject.timestamp)
print "Requested events %s" % userObject.requested_events
print "Running events %s" % userObject.running_events
print "Completed events %s" % userObject.done_events

userObject = monitoringCore.getUserProductionStatus (385)
userInfo = security_api.getAllFromID (385)
print "ProdRequest user %s stats on %s" % (userInfo, userObject.timestamp)
print "Requested events %s" % userObject.requested_events
print "Running events %s" % userObject.running_events
print "Completed events %s" % userObject.done_events

from Models import PhysicsGroup
groups = PhysicsGroup._enum__dict.items ()

for groupName, groupId  in groups:
    physicsGroupObject = monitoringCore.getPhysicsGroupProductionStatus (groupId)
    if physicsGroupObject:
        print "ProdRequest user %s stats on %s" % (groupName, physicsGroupObject.harvest_time)
        print "Requested events %s" % physicsGroupObject.requested_events
        print "Running events %s" % physicsGroupObject.running_events
        print "Completed events %s" % physicsGroupObject.done_events
    