from os import popen, getenv
from os.path import join

class ProdCommonPlugin (object):
    def __init__ (self, context, config):
        self.config=config
        prodrequestRoot = getenv ("PRODREQUEST_ROOT")
        sourceCmd = ""
        if prodrequestRoot:
            sourceCmd = "source %s; " %  join (prodrequestRoot, config["initFile"])

        scriptPosition = config["pluginLocation"].rsplit ("/",1)[0]
        self.creationScript = sourceCmd + "python %s/workflowCreator.py --request-id %%s --database %s" % (scriptPosition,
                                                                                                           "prodrequest.db")
    def createRequestSpec (self, requestId, cmsswVersion=None, cmsswInstallationRoot="/afs/cern.ch/cms/sw/slc3_ia32_gcc323"):
        cmsswEnvironment = ""
        print cmsswVersion
        print self.config
        if self.config.has_key ("setEnvironment"):
            cmsswEnvironment = "%s;" % self.config["setEnvironment"](None, cmsswVersion)
        elif cmsswVersion:
            pwd=getenv ("PWD")
            cmsswEnvironment = "cd %s/cms/cmssw/%s ; eval `scramv1 run -sh`; cd %s;" % (cmsswInstallationRoot, cmsswVersion, pwd)
        print cmsswEnvironment + self.creationScript % requestId
        specCreator = popen (cmsswEnvironment + self.creationScript % requestId)
        if self.config.has_key ("unsetEnvironment"):
            self.config["unsetEnvironment"](None, cmsswVersion)
        return specCreator.read ()
