from ProdRequestCommon.JSON import PythonListSerializer, PythonDictSerializer
from ProdRequestCommon.PersistencyTools import Serializer, Serializable
from Models import WorkflowEntry
from Models.RequestProxy import RequestProxy

serializer = PythonListSerializer ()
item1 = {"foo": "bar", "rebar": "1"}
list1 = [item1,item1,item1]
assert (serializer (list1) == """[{'foo': 'bar', 'rebar': '1'}, 
{'foo': 'bar', 'rebar': '1'}, 
{'foo': 'bar', 'rebar': '1'}]""".replace ("\n", ""))
item2 = {"foo": [1,2,3]}
list2 = [item2, item2]
assert (serializer (list2) == """[{'foo': [1, 2, 3]}, {'foo': [1, 2, 3]}]""")
list3 = [item1, item2, {"foo": item1, "bar": [item2, item1]}, [item1,item1]]
assert (serializer (list3) == """[{'foo': 'bar', 'rebar': '1'}, 
{'foo': [1, 2, 3]}, {'foo': {'foo': 'bar', 'rebar': '1'}, 
'bar': [{'foo': [1, 2, 3]}, {'foo': 'bar', 'rebar': '1'}]}, 
[{'foo': 'bar', 'rebar': '1'}, {'foo': 'bar', 'rebar': '1'}]]
""".replace ("\n", ""))

entry = WorkflowEntry.get (1)
proxy = RequestProxy (entry, "ktf")
proxySerializer = Serializer (type (proxy))
serializable = Serializable (proxy, proxySerializer)
for name, dumper in proxySerializer:
    print name, dumper (proxy) 
serializer = PythonDictSerializer ()
print serializer ({"request": serializable})