from ProdRequestCommon.DataBase.ProdRequestApi import QueryMaker
from ProdRequestCommon.DataBase.ProdRequestApi import buildQueryFromUrl

maker = QueryMaker ("cmssw")
maker.addField ("architecture.name")
maker.addSimpleCondition ("architecture.name", "slc3_ia32_gcc345")
print maker.createQuery ()
assert (maker.createQuery () == "select architecture.name from cmssw\ninner join architecture architecture on cmssw.architecture_id = architecture.id\nwhere architecture.name = :name;")
assert (maker.bindings () == {'name': 'slc3_ia32_gcc345'})

#maker2 = QueryMaker ("request")
#maker2.addField ("input_dataset.name")
#maker2.addField ("output_dataset.name")
#maker2.addField ("request.id")
#maker2.addSimpleCondition ("input_dataset.name", "foo")
#maker2.addSimpleCondition ("output_dataset.name", "bar")
#print maker2.createQuery ()
#print maker2.bindings () 

maker3 = QueryMaker ("request")
maker3.addField ("request.id")
maker3.addField ("dataset_info.primary_dataset.name")
maker3.addField ("physics_info.selection_efficiency")
maker3.addField ("requestor_info.physics_group.name")
maker3.addField ("production_info.requested_events")
maker3.addOrdering ("request.id", False)
assert (maker3.createQuery (limit=10, offset=20) == """select request.id, primary_dataset.name, physics_info.selection_efficiency, physics_group.name, production_info.requested_events from request
inner join dataset_info dataset_info on request.dataset_info_id = dataset_info.id
inner join primary_dataset primary_dataset on dataset_info.primary_dataset_id = primary_dataset.id
inner join physics_info physics_info on request.physics_info_id = physics_info.id
inner join requestor_info requestor_info on request.requestor_info_id = requestor_info.id
inner join physics_group physics_group on requestor_info.physics_group_id = physics_group.id
inner join production_info production_info on request.production_info_id = production_info.id
order by request.id DESC
limit 10
offset 20;""")

maker4 = QueryMaker ("request")
maker4.addField ("request.id")
maker4.addField ("dataset_info.primary_dataset.name")
maker4.addField ("physics_info.selection_efficiency")
maker4.addField ("requestor_info.physics_group.name")
maker4.addField ("production_info.requested_events")
maker4.addOrdering ("request.id", False)
maker4.addCondition ("requestor_info.physics_group.name", "Individual", "is")
maker4.addCondition ("production_info.requested_events", 1000, "gt")
#print maker4.createQuery (limit=10, offset=20)
assert (maker4.createQuery (limit=10, offset=20) == """select request.id, primary_dataset.name, physics_info.selection_efficiency, physics_group.name, production_info.requested_events from request
inner join dataset_info dataset_info on request.dataset_info_id = dataset_info.id
inner join primary_dataset primary_dataset on dataset_info.primary_dataset_id = primary_dataset.id
inner join physics_info physics_info on request.physics_info_id = physics_info.id
inner join requestor_info requestor_info on request.requestor_info_id = requestor_info.id
inner join physics_group physics_group on requestor_info.physics_group_id = physics_group.id
inner join production_info production_info on request.production_info_id = production_info.id
where production_info.requested_events > :requested_events AND physics_group.name = :name
order by request.id DESC
limit 10
offset 20;""")


(a, b, c) = buildQueryFromUrl ("/request/id/dataset_info.input_dataset[processed_dataset].name?q=is(dataset_info.input_dataset[processed_dataset].name,test);")
#print b
assert (b == """select request.id, input_dataset.name from request
inner join dataset_info dataset_info on request.dataset_info_id = dataset_info.id
inner join processed_dataset input_dataset on dataset_info.input_dataset_id = input_dataset.id
where input_dataset.name = :name;""")


(a, b, c) = buildQueryFromUrl ("/request/id/dataset_info.primary_dataset.name?q=is(dataset_info.input_dataset.name,test);")
#print b
assert (b == """select request.id, primary_dataset.name from request
inner join dataset_info dataset_info on request.dataset_info_id = dataset_info.id
inner join primary_dataset primary_dataset on dataset_info.primary_dataset_id = primary_dataset.id
inner join input_dataset input_dataset on dataset_info.input_dataset_id = input_dataset.id
where input_dataset.name = :name;""")
(a, b, c) = buildQueryFromUrl ("/request/id/dataset_info.primary_dataset.name/production_info.requested_events?q=contains(dataset_info.input_dataset[processed_dataset].name,App)")
#print b

(a,b,c) = buildQueryFromUrl ("/request/id/dataset_info.primary_dataset.name/production_info.requested_events/dataset_info.pileup_dataset[processed_dataset].name/dataset_info.pileup_dataset[processed_dataset].name/production_info.cmssw.version/production_info.cmssw.version?q=contains(dataset_info.input_dataset[processed_dataset].name,9)")
#assert (b == """select architecture.name from cmssw
#inner join architecture architecture on cmssw.architecture_id = architecture.id
#where architecture.name = :name;
#select request.id, primary_dataset.name, production_info.requested_events, pileup_dataset.name, cmssw.version from request
#inner join dataset_info dataset_info on request.dataset_info_id = dataset_info.id
#inner join primary_dataset primary_dataset on dataset_info.primary_dataset_id = primary_dataset.id
#inner join production_info production_info on request.production_info_id = production_info.id
#inner join processed_dataset pileup_dataset on dataset_info.pileup_dataset_id = pileup_dataset.id
#inner join cmssw cmssw on production_info.cmssw_id = cmssw.id
#inner join processed_dataset input_dataset on dataset_info.input_dataset_id = input_dataset.id
#where input_dataset.name LIKE :name;""")
#
(a,b,c) = buildQueryFromUrl("/request/request.current_log_entry[history_log].event_type.label?l=50&off=0")
print b

#
#(a, b, c) = buildQueryFromUrl ("/request/id/dataset_info.primary_dataset.name/physics_info.selection_efficiency/requestor_info.physics_group.name/production_info.requested_events?o=request_id&off=20&l=10&q=is(requestor_info.physics_group.name,Individual);gt(production_info.requested_events,100)")
#print b
#
#print maker3.bindings ()