#!/bin/sh
API=""
tag="CMSSW_1_1_0"

while [ $# -gt 0 ]
do
    case $1 in 
    --cgi )
        API="Cgi"
        shift
        ;;
    --tag )
        if [ $# -lt 1 ]; then echo "Option $1 needs at least one argument." ; exit 1; fi
        tag=$2
        shift; shift
        ;;
    * )
        echo "Unknown option $1"
        exit 1
        ;;
    esac
done

./injectCFGFile$API.py --tag $tag --workflow-name EcalTB Configuration/EcalTB/data/*.cfg
./injectCFGFile$API.py --tag $tag --workflow-name CSA06Skimming Configuration/CSA06Skimming/data/*.cfg
./injectCFGFile$API.py --tag $tag --workflow-name CSA06Production Configuration/CSA06Production/data/*.cfg
./injectCFGFile$API.py --tag $tag --workflow-name Application Configuration/Applications/data/*.cfg
./injectCFGFile$API.py --tag $tag --workflow-name ReleaseValidation Configuration/ReleaseValidation/data/*.cfg
