#!/usr/bin/env python

from getopt import getopt
from sys import argv
from os.path import exists
from sqlobject import *
conn = SQLiteConnection("prodrequest.db")
from Models import Payload, Workflow, WorkflowEntry
Payload._connection = conn
Workflow._connection = conn
WorkflowEntry._connection = conn

print argv
optlist, args = getopt (argv[1:], "w", ["workflow-name=","tag="])

options={}
print optlist

for key, value in optlist:
    options[key] = value

if not options.has_key ("--workflow-name"):
    print "Please specify the workflow name."
    exit

if not options.has_key ("--tag"):
    print "Please specify the tag to be used for this import"
    exit
    
workflowName=options["--workflow-name"]
tag=options["--tag"]
workflowSelect = Workflow.select (Workflow.q.name==workflowName)
if not workflowSelect.count ():
    workflowID = Workflow (name=workflowName).id
else:
    workflowID = workflowSelect[0].id
    
for cfgfile in args:
    if not exists (cfgfile):
        print cfgfile + " not found."
        pass
    
    cfg = file (cfgfile).read ()
    cfgname = cfgfile.rsplit ("/", 1)[1] + " - " + tag 
    payloadSelect = Payload.select (Payload.q.name==cfgname)
    if payloadSelect.count ():
        payloadID = payloadSelect[0].id
    else:
        payloadID = Payload (name=cfgname,
                             parameterset=cfg).id
    
    entrySelect = WorkflowEntry.select (WorkflowEntry.q.payload_id==payloadID)
    
    if entrySelect.count ():
        print "Already in there, skipping"
        continue
        
    WorkflowEntry (name=cfgname,
                   workflow_id=workflowID,
                   payload_id=payloadID,
                   payloadprev_id=0,
                   payloadparent_id=0,
                   status=0,
                   primary_dataset="None",
                   output_dataset="Modify me")
