#!/usr/bin/env python
# TODO: obsolete this file as soon as CVS browsing works.

from getopt import getopt
from sys import argv
from os.path import exists
from optparse import OptionParser
from os import getenv

import popen2
import sys
import os


# Code stolen from DBS/PythonAPI for POSTing in python. 
# This way there is not need for depending on ProdRequest directly.
# Kudos to Lassi!
from cStringIO import StringIO
import urllib2
import gzip 


def _encode(args):
    """
    Encode form (name, value) elements into multi-part/form-data.
    We don't actually need to know what we are uploading here, so
    just claim it's all text/plain.
    """
    boundary = '----------=_PRODREQUEST_CGI_BOUNDARY_=-----------'
    (body, crlf) = ('', '\r\n')
    for key, value in args.items():
        body += '--' + boundary + crlf
        body += ('Content-disposition: form-data; name="%s"' % key) + crlf
        body += crlf + value + crlf
    body += '--' + boundary + '--' + crlf + crlf
    return ('multipart/form-data; boundary=' + boundary, body)

def _marshall(args, request):
    """
    Marshalls the arguments to the CGI script as multi-part/form-data,
    not the default application/x-www-form-url-encoded.  This improves
    the transfer of the large inputs and eases command line invocation
    of the CGI script.
    """
    (type, body) = _encode(args)
    request.add_header ('Content-type', type)
    request.add_header ('Content-length', str(len(body)))
    request.add_data (body)

def _call (url, args):
    """
    Make a call to the CGI server, either a remote HTTP request (the
    URL is of the form http:*), or invoke the CGI as a local executable
    (the URL is of the form file:*).

    For the HTTP case, we build a request object, add the form data
    to as multipart/form-data, then fetch the result.  The output is
    compressed so we decompress it, parse out the DBS special HTTP
    headers for status code and error information, and raise errors
    as exceptions.  If all went well, we return the output to caller.

    The local execution is similar except we pass call details via
    environment variables and form data on standard input to the CGI
    script.  The output isn't compressed.  (FIXME: Not implemented!)
    """
    try:
        #request = urllib2.Request (self._cgiUrl, urllib.urlencode(args))
        request = urllib2.Request (url)
        request.add_header ('Accept-encoding', 'gzip')
        _marshall (args, request)
        result = urllib2.build_opener ().open (request)
        data = result.read()
        if result.headers.get ('Content-encoding', '') == 'gzip':
            data = gzip.GzipFile (fileobj=StringIO(data)).read ()
        return data
    except:
        pass

if __name__ == "__main__":
    optionParser = OptionParser ()
    optionParser.add_option ("-w", "--workflow-name", dest="workflowName", 
                             metavar="NAME", default="",
                             help="destination workflow NAME")
    optionParser.add_option ("-t", "--tag", dest="tag",
                             metavar="TAG", default="",
                             help="CMSSW TAG")                             
    optionParser.add_option ("-s", "--server", dest="prodrequestUrl", 
                             metavar="URL", default="cmsdoc.cern.ch/cms/test/aprom/DBS/prodrequest",
                             help="ProdRequest URL")
    
    options, args = optionParser.parse_args ()
    
    if not options.workflowName:
        print "Please specify the workflow name."
        exit
    
    if not options.tag:
        print "Please specify the tag to be used for this import"
        exit
    
    if not len (args):
        print "Please specify at least one configuration file to be injected."
        exit
        
    for cfgfile in args:
        if not exists (cfgfile):
            print cfgfile + " not found."
            pass
        
        cfg = file (cfgfile).read ()
        try:
            cfgname = cfgfile.rsplit ("/", 1)[1] + " - " + options.tag 
            version = os.getenv ("CMSSW_VERSION")
            print "CMSSW version: %s" % version
            print "Contacting http://%s/ProdRequest/createPayloadWithEntry" % options.prodrequestUrl
            result = _call ("http://%s/ProdRequest/createPayloadWithEntry" % options.prodrequestUrl,
                            {"name": cfgname,
                            "parameterset": cfg,
                            "primary_dataset": "primary_dataset",
                            "output_dataset": "output_dataset",
                            "workflowName": options.workflowName,
                            "version": version})
            print result
        except Exception, e:
            print "Cannot convert: %s" % cfgfile
            print "%s" % e
            