#!/bin/sh
# To be run from the prodrequest 0.6.0 area.
source etc/profile.d/init.sh

# First of all lets start the new cmsWeb which will create the new prodrequest.db and the new sitedb_test.db. 
cmsWeb --port 8031
# let's import hn usernames and passwords in the new sitedb db.
python ../../webtools/1.0.0/lib/python2.4/site-packages/Tools/SecurityModuleCore/bin/importHNShadow.py -f hn_passwd_20070515a.out -d sitedb_test.db

# Let's copy the old dbs in the current area
cp -f ../0.5.0/security.db ./security.db.migration
cp -f ../0.5.0/prodrequest.db ./prodrequest.db.old
cp -f ../0.5.0/prodrequest.db ../0.6.0/prodrequest.db
cp -f ../0.6.0/sitedb_test.db ../0.6.0/sitedb_test.db.old

# Let's copy the old roles in the new sitedb and update the group responsibility table.  
sqlite3 sitedb_test.db <<\EOF
attach "security.db.migration" as security;

INSERT OR REPLACE INTO user_group (name) SELECT region FROM auth_z_region;
INSERT OR REPLACE INTO role (title) SELECT role FROM auth_z_role;

INSERT OR IGNORE INTO group_responsibility (contact, user_group, role) 
SELECT newu.id, newg.id, newr.id
FROM security.auth_z_user_role oldur
    JOIN security.auth_n_user oldu ON oldu.id = oldur.user_id
    JOIN security.auth_z_region oldg ON oldg.id = oldur.region_id
    JOIN security.auth_z_role oldr ON oldr.id = oldur.role_id
    JOIN contact newu ON newu.username = oldu.username
    JOIN user_group newg ON newg.name = oldg.region
    JOIN role newr ON newr.title = oldr.role;
EOF

# Let's update the table with the owner of a given workflow with the new user_id.
sqlite3 prodrequest.db << \EOF
attach "security.db.migration" as security;
attach "prodrequest.db.old" as prodrequestold;
attach "sitedb_test.db.migration" as sitedb;
UPDATE workflow SET owner_id
    = (SELECT c.id 
       FROM sitedb.contact c
         JOIN security.auth_n_user n ON n.username = c.username
         JOIN prodrequestold.workflow ow ON ow.owner_id = n.id
       WHERE ow.owner_id = workflow.owner_id);
EOF

sqlite3 prodrequest.db << \EOF
attach "sitedb_test.db" as sitedb;
ALTER TABLE location ADD COLUMN user_group INTEGER;
UPDATE OR REPLACE location SET name="OSG team 1" WHERE name="OSG";
UPDATE OR REPLACE location SET name="LCG team 7" WHERE name="LCG team 9";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 1") WHERE name="LCG team 1";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 2") WHERE name="LCG team 2";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 3") WHERE name="LCG team 3";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 4") WHERE name="LCG team 4";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 5") WHERE name="LCG team 5";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 6") WHERE name="LCG team 6";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 7") WHERE name="LCG team 7";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="OSG production team 1") WHERE name="OSG team 1";
EOF

# Let's rename some of the roles and groups.
sqlite3 sitedb_test.db <<\EOF
attach "security.db.migration" as security;
UPDATE OR REPLACE role SET title="Production Manager" WHERE title="PRODUCTION_MANAGER";
UPDATE OR REPLACE role SET title="Production Operator" WHERE title="PRODUCTION_OPERATOR";  
UPDATE OR REPLACE role SET title="Global Admin" WHERE title="ADMIN";
UPDATE OR REPLACE user_group SET name="LCG production team 1" WHERE name="LCG_PRODUCTION_GROUP_1";
UPDATE OR REPLACE user_group SET name="LCG production team 2" WHERE name="LCG_PRODUCTION_GROUP_2";
UPDATE OR REPLACE user_group SET name="LCG production team 3" WHERE name="LCG_PRODUCTION_GROUP_3";
UPDATE OR REPLACE user_group SET name="LCG production team 4" WHERE name="LCG_PRODUCTION_GROUP_4";
UPDATE OR REPLACE user_group SET name="LCG production team 5" WHERE name="LCG_PRODUCTION_GROUP_5";
UPDATE OR REPLACE user_group SET name="LCG production team 6" WHERE name="LCG_PRODUCTION_GROUP_6";
UPDATE OR REPLACE user_group SET name="LCG production team 7" WHERE name="LCG_PRODUCTION_GROUP_9";
UPDATE OR REPLACE user_group SET name="OSG production team 1" WHERE name="OSG_PRODUCTION_GROUP_1";
UPDATE OR REPLACE user_group SET name="ProdRequest" WHERE name="PRODREQUEST";
UPDATE OR REPLACE user_group SET name="global" WHERE name="SECURITY";
EOF

#TODO: udpate workflow_entry to pick up cmssw_version from the workflow table.
sqlite3 prodrequest.db << \EOF
ALTER TABLE workflow_entry ADD COLUMN prodcommon_version;
UPDATE workflow_entry SET prodcommon_version="PRODCOMMON_0_2_X";
EOF

#sqlite3 sitedb_test.db << \EOF
#UPDATE user_passwd SET passwd="forh75ZkVhdTU"; 
#EOF

sqlite3 prodrequest.db << \EOF
ALTER TABLE workflow_entry ADD COLUMN owner_id INTEGER;
ALTER TABLE workflow_entry ADD COLUMN request_spec TEXT;
UPDATE workflow_entry SET owner_id
    = (SELECT w.owner_id 
       FROM workflow w
            WHERE w.id = workflow_entry.workflow_id);
EOF

sqlite3 prodrequest.db << \EOF
DELETE FROM workflow_entry WHERE id=1585;
DELETE FROM workflow_entry WHERE id=1586;
EOF

sqlite3 prodrequest.db << \EOF
ATTACH "sitedb_test.db" as sitedb;
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 1") WHERE name="LCG team 1";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 2") WHERE name="LCG team 2";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 3") WHERE name="LCG team 3";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 4") WHERE name="LCG team 4";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 5") WHERE name="LCG team 5";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 6") WHERE name="LCG team 6";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="LCG production team 7") WHERE name="LCG team 7";
UPDATE location SET user_group=(SELECT id FROM sitedb.user_group WHERE name="OSG production team 1") WHERE name="OSG team 1";
EOF

rm -rf migration
mkdir -p migration

